Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxextension.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxextension.c
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxextension.c
@@ -51,18 +51,38 @@
 #include "dmxgc.h"
 #include "dmxfont.h"
 #include "dmxcmap.h"
+#include "dmxshm.h"
 #ifdef RENDER
 #include "dmxpict.h"
 #endif
+#ifdef RANDR
+#include "dmxrandr.h"
+#endif
 #include "dmxinput.h"
+#include "dmxlog.h"
+#include "dmxgrab.h"
 #include "dmxsync.h"
 #include "dmxscrinit.h"
-#include "input/dmxinputinit.h"
+#ifdef XV
+#include "dmxxv.h"
+#endif
 
 #include "windowstr.h"
 #include "inputstr.h"                 /* For DeviceIntRec */
 #include <X11/extensions/dmxproto.h>  /* For DMX_BAD_* */
 #include "cursorstr.h"
+#include "propertyst.h"
+
+#ifdef PANORAMIX
+#include "panoramiXsrv.h"
+#endif
+
+#define dmxErrorSet(set, error, name, fmt, ...)       \
+    if (set) (*set) (error, name, fmt, ##__VA_ARGS__)
+
+#define dmxLogErrorSet(type, set, error, name, fmt, ...) \
+    dmxLog (type, fmt "\n", ##__VA_ARGS__);		 \
+    dmxErrorSet (set, error, name, fmt, ##__VA_ARGS__)
 
 /* The default font is declared in dix/globals.c, but is not included in
  * _any_ header files. */
@@ -77,7 +97,8 @@ Bool dmxGetScreenAttributes(int physical
     if (physical < 0 || physical >= dmxNumScreens) return FALSE;
 
     dmxScreen = &dmxScreens[physical];
-    attr->displayName         = dmxScreen->name;
+    attr->name                = dmxScreen->name;
+    attr->displayName         = dmxScreen->display;
 #ifdef PANORAMIX
     attr->logicalScreen       = noPanoramiXExtension ? dmxScreen->index : 0;
 #else
@@ -86,16 +107,25 @@ Bool dmxGetScreenAttributes(int physical
 
     attr->screenWindowWidth   = dmxScreen->scrnWidth;
     attr->screenWindowHeight  = dmxScreen->scrnHeight;
-    attr->screenWindowXoffset = dmxScreen->scrnX;
-    attr->screenWindowYoffset = dmxScreen->scrnY;
+    attr->screenWindowXoffset = 0;
+    attr->screenWindowYoffset = 0;
+
+    attr->rootWindowWidth     = WindowTable[physical]->drawable.width;
+    attr->rootWindowHeight    = WindowTable[physical]->drawable.height;
+
+#ifdef PANORAMIX
+    if (!noPanoramiXExtension)
+    {
+	attr->rootWindowWidth  = PanoramiXPixWidth;
+	attr->rootWindowHeight = PanoramiXPixHeight;
+    }
+#endif
 
-    attr->rootWindowWidth     = dmxScreen->rootWidth;
-    attr->rootWindowHeight    = dmxScreen->rootHeight;
     attr->rootWindowXoffset   = dmxScreen->rootX;
     attr->rootWindowYoffset   = dmxScreen->rootY;
 
-    attr->rootWindowXorigin   = dmxScreen->rootXOrigin;
-    attr->rootWindowYorigin   = dmxScreen->rootYOrigin;
+    attr->rootWindowXorigin   = 0;
+    attr->rootWindowYorigin   = 0;
 
     return TRUE;
 }
@@ -156,6 +186,76 @@ Bool dmxGetWindowAttributes(WindowPtr pW
     return TRUE;
 }
 
+/** This routine provides information to the DMX protocol extension
+ * about a particular window. */
+Bool dmxGetDrawableAttributes(DrawablePtr pDraw, DMXWindowAttributesPtr attr)
+{
+    if ((pDraw->type == UNDRAWABLE_WINDOW) || (pDraw->type == DRAWABLE_WINDOW))
+    {
+	WindowPtr pWindow = (WindowPtr) pDraw;
+	dmxWinPrivPtr pWinPriv = DMX_GET_WINDOW_PRIV (pWindow);
+
+	attr->screen         = pWindow->drawable.pScreen->myNum;
+	attr->window         = pWinPriv->window;
+
+	attr->pos.x          = pWindow->drawable.x;
+	attr->pos.y          = pWindow->drawable.y;
+	attr->pos.width      = pWindow->drawable.width;
+	attr->pos.height     = pWindow->drawable.height;
+
+	if (!pWinPriv->window || pWinPriv->offscreen) {
+	    attr->vis.x      = 0;
+	    attr->vis.y      = 0;
+	    attr->vis.height = 0;
+	    attr->vis.width  = 0;
+	    return pWinPriv->window ? TRUE : FALSE;
+	}
+
+	/* Compute display-relative coordinates */
+	attr->vis.x          = pWindow->drawable.x;
+	attr->vis.y          = pWindow->drawable.y;
+	attr->vis.width      = pWindow->drawable.width;
+	attr->vis.height     = pWindow->drawable.height;
+
+	if (attr->pos.x < 0) {
+	    attr->vis.x     -= attr->pos.x;
+	    attr->vis.width  = attr->pos.x + attr->pos.width - attr->vis.x;
+	}
+	if (attr->pos.x + attr->pos.width > pWindow->drawable.pScreen->width) {
+	    if (attr->pos.x < 0)
+		attr->vis.width  = pWindow->drawable.pScreen->width;
+	    else
+		attr->vis.width  = pWindow->drawable.pScreen->width - attr->pos.x;
+	}
+	if (attr->pos.y < 0) {
+	    attr->vis.y     -= attr->pos.y;
+	    attr->vis.height = attr->pos.y + attr->pos.height - attr->vis.y;
+	}
+	if (attr->pos.y + attr->pos.height > pWindow->drawable.pScreen->height) {
+	    if (attr->pos.y < 0)
+		attr->vis.height = pWindow->drawable.pScreen->height;
+	    else
+		attr->vis.height = pWindow->drawable.pScreen->height - attr->pos.y;
+	}
+
+	/* Convert to window-relative coordinates */
+	attr->vis.x -= attr->pos.x;
+	attr->vis.y -= attr->pos.y;
+    }
+    else
+    {
+	PixmapPtr pPixmap = (PixmapPtr) pDraw;
+	dmxPixPrivPtr pPixPriv = DMX_GET_PIXMAP_PRIV (pPixmap);
+	xRectangle empty = { 0, 0, 0, 0 };
+
+	attr->screen = pDraw->pScreen->myNum;
+	attr->window = pPixPriv->pixmap;
+	attr->pos = attr->vis = empty;
+    }
+
+    return TRUE;
+}
+
 void dmxGetDesktopAttributes(DMXDesktopAttributesPtr attr)
 {
     attr->width  = dmxGlobalWidth;
@@ -171,7 +271,9 @@ int dmxGetInputCount(void)
 {
     int i, total;
     
-    for (total = i = 0; i < dmxNumInputs; i++) total += dmxInputs[i].numDevs;
+    for (total = i = 0; i < dmxNumScreens; i++)
+	total += dmxScreens[i].input.numDevs;
+
     return total;
 }
 
@@ -185,89 +287,83 @@ int dmxGetInputAttributes(int deviceId,
     DMXInputInfo *dmxInput;
 
     if (deviceId < 0) return -1;
-    for (i = 0; i < dmxNumInputs; i++) {
-        dmxInput = &dmxInputs[i];
+    for (i = 0; i < dmxNumScreens; i++) {
+        dmxInput = &dmxScreens[i].input;
         for (j = 0; j < dmxInput->numDevs; j++) {
-            DMXLocalInputInfoPtr dmxLocal = dmxInput->devs[j];
-            if (deviceId != dmxLocal->pDevice->id) continue;
-            attr->isCore             = !!dmxLocal->isCore;
-            attr->sendsCore          = !!dmxLocal->sendsCore;
-            attr->detached           = !!dmxInput->detached;
-            attr->physicalScreen     = -1;
-            attr->physicalId         = -1;
-            attr->name               = NULL;
-            switch (dmxLocal->extType) {
-            case DMX_LOCAL_TYPE_LOCAL:
-                attr->inputType      = 0;
-                break;
-            case DMX_LOCAL_TYPE_CONSOLE:
-                attr->inputType      = 1;
-                attr->name           = dmxInput->name;
-                attr->physicalId     = dmxLocal->deviceId;
-                break;
-            case DMX_LOCAL_TYPE_BACKEND:
-            case DMX_LOCAL_TYPE_COMMON:
-                attr->inputType      = 2;
-                attr->physicalScreen = dmxInput->scrnIdx;
-                attr->name           = dmxInput->name;
-                attr->physicalId     = dmxLocal->deviceId;
-                break;
-            }
-            return 0;           /* Success */
+            if (deviceId != dmxInput->devs[i]->id) continue;
+            attr->isCore         = FALSE;
+            attr->sendsCore      = TRUE;
+            attr->detached       = FALSE;
+	    attr->inputType      = 2;
+	    attr->physicalScreen = i;
+	    attr->name           = dmxInput->devs[i]->name;
+	    attr->physicalId     = deviceId;
+	    return 0;           /* Success */
         }
     }
     return -1;                  /* Failure */
 }
 
-/** Reinitialized the cursor boundaries. */
-static void dmxAdjustCursorBoundaries(void)
-{
-    int           i;
-
-    dmxReInitOrigins();
-    dmxInitOverlap();
-    dmxComputeWidthHeight(DMX_NO_RECOMPUTE_BOUNDING_BOX);
-    dmxConnectionBlockCallback();
-    for (i = 0; i < dmxNumInputs; i++) {
-        DMXInputInfo *dmxInput = &dmxInputs[i];
-	if (!dmxInput->detached) dmxInputReInit(dmxInput);
-    }
-
-    dmxCheckCursor();
-
-    for (i = 0; i < dmxNumInputs; i++) {
-        DMXInputInfo *dmxInput = &dmxInputs[i];
-	if (!dmxInput->detached) dmxInputLateReInit(dmxInput);
-    }
-}
-
 /** Add an input with the specified attributes.  If the input is added,
  * the physical id is returned in \a deviceId. */
 int dmxAddInput(DMXInputAttributesPtr attr, int *id)
 {
-    int retcode = BadValue;
+    if (attr->physicalScreen < 0 || attr->physicalScreen >= dmxNumScreens)
+	return BadValue;
 
-    if (attr->inputType == 1)   /* console */
-        retcode = dmxInputAttachConsole(attr->name, attr->sendsCore, id);
-    else if (attr->inputType == 2)   /* backend */
-        retcode = dmxInputAttachBackend(attr->physicalScreen,
-                                        attr->sendsCore,id);
+    if (attr->inputType == 2)
+    {
+	DMXScreenInfo *dmxScreen = &dmxScreens[attr->physicalScreen];
+	int           ret;
+
+	if (dmxScreen->beDisplay)
+	{
+	    ret = dmxInputAttach (&dmxScreen->input);
+	    if (ret != Success)
+		return ret;
 
-    if (retcode == Success) {
-        /* Adjust the cursor boundaries */
-        dmxAdjustCursorBoundaries();
+	    dmxInputEnable (&dmxScreen->input);
+	}
+	else
+	{
+	    dmxScreen->beDisplay = dmxScreen->beAttachedDisplay;
+	    ret = dmxInputAttach (&dmxScreen->input);
+	    dmxScreen->beDisplay = NULL;
+	
+	    if (ret != Success)
+		return ret;
+	}
 
-        /* Force completion of the changes */
-        dmxSync(NULL, TRUE);
+	*id = attr->physicalScreen;
+
+	return ret;
     }
 
-    return retcode;
+    return BadValue;
 }
 
 /** Remove the input with physical id \a id. */
 int dmxRemoveInput(int id)
 {
-    return dmxInputDetachId(id);
+    int ret;
+
+    if (id < 0 || id >= dmxNumScreens)
+	return BadValue;
+
+    if (dmxScreens[id].beDisplay)
+    {
+	dmxInputDisable (&dmxScreens[id].input);
+	ret = dmxInputDetach (&dmxScreens[id].input);
+    }
+    else
+    {
+	dmxScreens[id].beDisplay = dmxScreens[id].beAttachedDisplay;
+	ret = dmxInputDetach (&dmxScreens[id].input);
+	dmxScreens[id].beDisplay = NULL;
+
+    }
+
+    return ret;
 }
 
 /** Return the value of #dmxNumScreens -- the total number of backend
@@ -370,307 +466,6 @@ void dmxUpdateScreenResources(ScreenPtr
     }
 }
 
-#ifdef PANORAMIX
-#include "panoramiXsrv.h"
-
-/** Change the "screen" window attributes by resizing the actual window
- *  on the back-end display (if necessary). */
-static void dmxConfigureScreenWindow(int idx,
-				     int x, int y, int w, int h)
-{
-    DMXScreenInfo *dmxScreen = &dmxScreens[idx];
-    ScreenPtr      pScreen   = screenInfo.screens[idx];
-
-    /* Resize "screen" window */
-    if (dmxScreen->scrnX      != x ||
-	dmxScreen->scrnY      != y ||
-	dmxScreen->scrnWidth  != w ||
-	dmxScreen->scrnHeight != h) {
-	dmxResizeScreenWindow(pScreen, x, y, w, h);
-    }
-
-    /* Change "screen" window values */
-    dmxScreen->scrnX      = x;
-    dmxScreen->scrnY      = y;
-    dmxScreen->scrnWidth  = w;
-    dmxScreen->scrnHeight = h;
-}
-				     
-/** Change the "root" window position and size by resizing the actual
- *  window on the back-end display (if necessary) and updating all of
- *  DMX's resources by calling #dmxUpdateScreenResources. */
-static void dmxConfigureRootWindow(int idx, int x, int y, int w, int h)
-{
-    DMXScreenInfo *dmxScreen = &dmxScreens[idx];
-    WindowPtr      pRoot     = WindowTable[idx];
-
-    /* NOTE: Either this function or the ones that it calls must handle
-     * the case where w == 0 || h == 0.  Currently, the functions that
-     * this one calls handle that case. */
-
-    /* 1. Resize "root" window */
-    if (dmxScreen->rootX      != x ||
-	dmxScreen->rootY      != y ||
-	dmxScreen->rootWidth  != w ||
-	dmxScreen->rootHeight != h) {
-	dmxResizeRootWindow(pRoot, x, y, w, h);
-    }
-
-    /* 2. Update all of the screen's resources associated with this root
-     *    window */
-    if (dmxScreen->rootWidth  != w ||
-	dmxScreen->rootHeight != h) {
-	dmxUpdateScreenResources(screenInfo.screens[idx], x, y, w, h);
-    }
-
-    /* Change "root" window values */
-    dmxScreen->rootX      = x;
-    dmxScreen->rootY      = y;
-    dmxScreen->rootWidth  = w;
-    dmxScreen->rootHeight = h;
-}
-
-/** Change the "root" window's origin by updating DMX's internal data
- *  structures (dix and Xinerama) to use the new origin and adjust the
- *  positions of windows that overlap this "root" window. */
-static void dmxSetRootWindowOrigin(int idx, int x, int y)
-{
-    DMXScreenInfo *dmxScreen = &dmxScreens[idx];
-    ScreenPtr      pScreen   = screenInfo.screens[idx];
-    WindowPtr      pRoot     = WindowTable[idx];
-    WindowPtr      pChild;
-    int            xoff;
-    int            yoff;
-
-    /* Change "root" window's origin */
-    dmxScreen->rootXOrigin = x;
-    dmxScreen->rootYOrigin = y;
-
-    /* Compute offsets here in case <x,y> has been changed above */
-    xoff = x - dixScreenOrigins[idx].x;
-    yoff = y - dixScreenOrigins[idx].y;
-
-    /* Adjust the root window's position in dixScreenOrigins */
-    dixScreenOrigins[idx].x = dmxScreen->rootXOrigin;
-    dixScreenOrigins[idx].y = dmxScreen->rootYOrigin;
-
-    /* Recalculate the Xinerama regions and data structs */
-    XineramaReinitData(pScreen);
-
-    /* Adjust each of the root window's children */
-    if (!idx) ReinitializeRootWindow(WindowTable[0], xoff, yoff);
-    pChild = pRoot->firstChild;
-    while (pChild) {
-	/* Adjust child window's position */
-	pScreen->MoveWindow(pChild,
-			    pChild->origin.x - wBorderWidth(pChild) - xoff,
-			    pChild->origin.y - wBorderWidth(pChild) - yoff,
-			    pChild->nextSib,
-			    VTMove);
-
-	/* Note that the call to MoveWindow will eventually call
-	 * dmxPositionWindow which will automatically create a
-	 * window if it is now exposed on screen (for lazy window
-	 * creation optimization) and it will properly set the
-	 * offscreen flag.
-	 */
-
-	pChild = pChild->nextSib;
-    }
-}
-
-/** Configure the attributes of each "screen" and "root" window. */
-int dmxConfigureScreenWindows(int nscreens,
-			      CARD32 *screens,
-			      DMXScreenAttributesPtr attribs,
-			      int *errorScreen)
-{
-    int           i;
-
-    for (i = 0; i < nscreens; i++) {
-	DMXScreenAttributesPtr  attr      = &attribs[i];
-	int                     idx       = screens[i];
-	DMXScreenInfo          *dmxScreen = &dmxScreens[idx];
-
-	if (errorScreen) *errorScreen = i;
-
-	if (!dmxScreen->beDisplay) return DMX_BAD_VALUE;
-
-	/* Check for illegal values */
-	if (idx < 0 || idx >= dmxNumScreens) return BadValue;
-
-	/* The "screen" and "root" windows must have valid sizes */
-	if (attr->screenWindowWidth <= 0 || attr->screenWindowHeight <= 0 ||
-	    attr->rootWindowWidth   <  0 || attr->rootWindowHeight   <  0)
-	    return DMX_BAD_VALUE;
-
-	/* The "screen" window must fit entirely within the BE display */
-	if (attr->screenWindowXoffset < 0 ||
-	    attr->screenWindowYoffset < 0 ||
-	    attr->screenWindowXoffset
-	    + attr->screenWindowWidth  > (unsigned)dmxScreen->beWidth ||
-	    attr->screenWindowYoffset
-	    + attr->screenWindowHeight > (unsigned)dmxScreen->beHeight)
-	    return DMX_BAD_VALUE;
-
-	/* The "root" window must fit entirely within the "screen" window */
-	if (attr->rootWindowXoffset < 0 ||
-	    attr->rootWindowYoffset < 0 ||
-	    attr->rootWindowXoffset
-	    + attr->rootWindowWidth  > attr->screenWindowWidth ||
-	    attr->rootWindowYoffset
-	    + attr->rootWindowHeight > attr->screenWindowHeight)
-	    return DMX_BAD_VALUE;
-
-	/* The "root" window must not expose unaddressable coordinates */
-	if (attr->rootWindowXorigin < 0 ||
-	    attr->rootWindowYorigin < 0 ||
-	    attr->rootWindowXorigin + attr->rootWindowWidth  > 32767 ||
-	    attr->rootWindowYorigin + attr->rootWindowHeight > 32767)
-	    return DMX_BAD_VALUE;
-
-	/* The "root" window must fit within the global bounding box */
-	if (attr->rootWindowXorigin
-	    + attr->rootWindowWidth > (unsigned)dmxGlobalWidth ||
-	    attr->rootWindowYorigin
-	    + attr->rootWindowHeight > (unsigned)dmxGlobalHeight)
-	    return DMX_BAD_VALUE;
-
-	/* FIXME: Handle the rest of the illegal value checking */
-    }
-
-    /* No illegal values found */
-    if (errorScreen) *errorScreen = 0;
-
-    for (i = 0; i < nscreens; i++) {
-	DMXScreenAttributesPtr  attr      = &attribs[i];
-	int                     idx       = screens[i];
-	DMXScreenInfo          *dmxScreen = &dmxScreens[idx];
-
-	dmxLog(dmxInfo, "Changing screen #%d attributes "
-	       "from %dx%d+%d+%d %dx%d+%d+%d +%d+%d "
-	       "to %dx%d+%d+%d %dx%d+%d+%d +%d+%d\n",
-	       idx,
-	       dmxScreen->scrnWidth,      dmxScreen->scrnHeight,
-	       dmxScreen->scrnX,          dmxScreen->scrnY,
-	       dmxScreen->rootWidth,      dmxScreen->rootHeight,
-	       dmxScreen->rootX,          dmxScreen->rootY,
-	       dmxScreen->rootXOrigin,    dmxScreen->rootYOrigin,
-	       attr->screenWindowWidth,   attr->screenWindowHeight,
-	       attr->screenWindowXoffset, attr->screenWindowYoffset,
-	       attr->rootWindowWidth,     attr->rootWindowHeight,
-	       attr->rootWindowXoffset,   attr->rootWindowYoffset,
-	       attr->rootWindowXorigin,   attr->rootWindowYorigin);
-
-	/* Configure "screen" window */
-	dmxConfigureScreenWindow(idx,
-				 attr->screenWindowXoffset,
-				 attr->screenWindowYoffset,
-				 attr->screenWindowWidth,
-				 attr->screenWindowHeight);
-
-	/* Configure "root" window */
-	dmxConfigureRootWindow(idx,
-			       attr->rootWindowXoffset,
-			       attr->rootWindowYoffset,
-			       attr->rootWindowWidth,
-			       attr->rootWindowHeight);
-
-
-	/* Set "root" window's origin */
-	dmxSetRootWindowOrigin(idx,
-			       attr->rootWindowXorigin,
-			       attr->rootWindowYorigin);
-    }
-
-    /* Adjust the cursor boundaries */
-    dmxAdjustCursorBoundaries();
-
-    /* Force completion of the changes */
-    dmxSync(NULL, TRUE);
-
-    return Success;
-}
-
-/** Configure the attributes of the global desktop. */
-int dmxConfigureDesktop(DMXDesktopAttributesPtr attribs)
-{
-    if (attribs->width  <= 0 || attribs->width  >= 32767 ||
-	attribs->height <= 0 || attribs->height >= 32767)
-	return DMX_BAD_VALUE;
-
-    /* If the desktop is shrinking, adjust the "root" windows on each
-     * "screen" window to only show the visible desktop.  Also, handle
-     * the special case where the desktop shrinks such that the it no
-     * longer overlaps an portion of a "screen" window. */
-    if (attribs->width < dmxGlobalWidth || attribs->height < dmxGlobalHeight) {
-	int   i;
-	for (i = 0; i < dmxNumScreens; i++) {
-	    DMXScreenInfo *dmxScreen = &dmxScreens[i];
-	    if (dmxScreen->rootXOrigin
-		+ dmxScreen->rootWidth  > attribs->width ||
-		dmxScreen->rootYOrigin
-		+ dmxScreen->rootHeight > attribs->height) {
-		int  w, h;
-		if ((w = attribs->width  - dmxScreen->rootXOrigin) < 0) w = 0;
-		if ((h = attribs->height - dmxScreen->rootYOrigin) < 0) h = 0;
-		if (w > dmxScreen->scrnWidth)  w = dmxScreen->scrnWidth;
-		if (h > dmxScreen->scrnHeight) h = dmxScreen->scrnHeight;
-		if (w > dmxScreen->rootWidth)  w = dmxScreen->rootWidth;
-		if (h > dmxScreen->rootHeight) h = dmxScreen->rootHeight;
-		dmxConfigureRootWindow(i,
-				       dmxScreen->rootX,
-				       dmxScreen->rootY,
-				       w, h);
-	    }
-	}
-    }
-
-    /* Set the global width/height */
-    dmxSetWidthHeight(attribs->width, attribs->height);
-
-    /* Handle shift[XY] changes */
-    if (attribs->shiftX || attribs->shiftY) {
-	int   i;
-	for (i = 0; i < dmxNumScreens; i++) {
-	    ScreenPtr  pScreen = screenInfo.screens[i];
-	    WindowPtr  pChild  = WindowTable[i]->firstChild;
-	    while (pChild) {
-		/* Adjust child window's position */
-		pScreen->MoveWindow(pChild,
-				    pChild->origin.x - wBorderWidth(pChild)
-				    - attribs->shiftX,
-				    pChild->origin.y - wBorderWidth(pChild)
-				    - attribs->shiftY,
-				    pChild->nextSib,
-				    VTMove);
-
-		/* Note that the call to MoveWindow will eventually call
-		 * dmxPositionWindow which will automatically create a
-		 * window if it is now exposed on screen (for lazy
-		 * window creation optimization) and it will properly
-		 * set the offscreen flag.
-		 */
-
-		pChild = pChild->nextSib;
-	    }
-	}
-    }
-
-    /* Update connection block, Xinerama, etc. -- these appears to
-     * already be handled in dmxConnectionBlockCallback(), which is
-     * called from dmxAdjustCursorBoundaries() [below]. */
-
-    /* Adjust the cursor boundaries */
-    dmxAdjustCursorBoundaries();
-
-    /* Force completion of the changes */
-    dmxSync(NULL, TRUE);
-
-    return Success;
-}
-#endif
-
 /** Create the scratch GCs per depth. */
 static void dmxBECreateScratchGCs(int scrnNum)
 {
@@ -685,6 +480,8 @@ static void dmxBECreateScratchGCs(int sc
 #ifdef PANORAMIX
 static Bool FoundPixImage;
 
+extern unsigned long	XRT_PICTURE;
+
 /** Search the Xinerama XRT_PIXMAP resources for the pixmap that needs
  *  to have its image restored.  When it is found, see if there is
  *  another screen with the same image.  If so, copy the pixmap image
@@ -692,46 +489,128 @@ static Bool FoundPixImage;
 static void dmxBERestorePixmapImage(pointer value, XID id, RESTYPE type,
 				    pointer p)
 {
+    PixmapPtr pSrc = NULL;
+    PixmapPtr pDst = (PixmapPtr) p;
+    int       idx      = pDst->drawable.pScreen->myNum;
+    int       i;
+
     if ((type & TypeMask) == (XRT_PIXMAP & TypeMask)) {
-	PixmapPtr      pDst     = (PixmapPtr)p;
 	int            idx      = pDst->drawable.pScreen->myNum;
 	PanoramiXRes  *pXinPix  = (PanoramiXRes *)value;
 	PixmapPtr      pPix;
-	int            i;
 
 	pPix = (PixmapPtr)LookupIDByType(pXinPix->info[idx].id, RT_PIXMAP);
 	if (pPix != pDst) return; /* Not a match.... Next! */
 
-	for (i = 0; i < PanoramiXNumScreens; i++) {
-	    PixmapPtr      pSrc;
-	    dmxPixPrivPtr  pSrcPriv = NULL;
-
+	for (i = 0; i < PanoramiXNumScreens; i++)
+	{
 	    if (i == idx) continue; /* Self replication is bad */
 
 	    pSrc =
 		(PixmapPtr)LookupIDByType(pXinPix->info[i].id, RT_PIXMAP);
-	    pSrcPriv = DMX_GET_PIXMAP_PRIV(pSrc);
-	    if (pSrcPriv->pixmap) {
-		DMXScreenInfo *dmxSrcScreen = &dmxScreens[i];
-		DMXScreenInfo *dmxDstScreen = &dmxScreens[idx];
-		dmxPixPrivPtr  pDstPriv = DMX_GET_PIXMAP_PRIV(pDst);
-		XImage        *img;
-		int            j;
-		XlibGC         gc = NULL;
-
-		/* This should never happen, but just in case.... */
-		if (pSrc->drawable.width  != pDst->drawable.width ||
-		    pSrc->drawable.height != pDst->drawable.height)
-		    return;
-
-		/* Copy from src pixmap to dst pixmap */
-		img = XGetImage(dmxSrcScreen->beDisplay,
-				pSrcPriv->pixmap,
-				0, 0,
-				pSrc->drawable.width, pSrc->drawable.height,
-				-1,
-				ZPixmap);
+	    break;
+	}
+    }
+
+#ifdef RENDER
+    else if ((type & TypeMask) == (XRT_PICTURE & TypeMask))
+    {
+	int           idx      = pDst->drawable.pScreen->myNum;
+	PanoramiXRes  *pXinPic  = (PanoramiXRes *) value;
+	PicturePtr    pPic;
+
+	pPic = (PicturePtr) LookupIDByType (pXinPic->info[idx].id,
+					    PictureType);
+
+	/* Not a match.... Next! */
+	if (!pPic || !pPic->pDrawable) return;
+	if (pPic->pDrawable->type != DRAWABLE_PIXMAP) return;
+	if (pPic->pDrawable != (DrawablePtr) pDst) return;
+
+	for (i = 0; i < PanoramiXNumScreens; i++)
+	{
+	    if (i == idx) continue; /* Self replication is bad */
+
+	    pPic = (PicturePtr) LookupIDByType (pXinPic->info[i].id,
+						PictureType);
+	    pSrc = (PixmapPtr) pPic->pDrawable;
+	    break;
+	}
+    }
+#endif
+
+    else if ((type & TypeMask) == (XRT_WINDOW & TypeMask))
+    {
+	PixmapPtr      pDst     = (PixmapPtr)p;
+	int            idx      = pDst->drawable.pScreen->myNum;
+	PanoramiXRes  *pXinWin  = (PanoramiXRes *) value;
+	Bool	      border;
+	WindowPtr     pWin;
+
+	pWin = (WindowPtr) LookupIDByType (pXinWin->info[idx].id, RT_WINDOW);
+
+	if (!pWin) return;
+	if (!pWin->borderIsPixel && pWin->border.pixmap == pDst)
+	{
+	    border = TRUE;
+	}
+	else if (pWin->backgroundState == BackgroundPixmap &&
+		 pWin->background.pixmap == pDst)
+	{
+	    border = FALSE;
+	}
+	else
+	{
+	    return;
+	}
+
+	for (i = 0; i < PanoramiXNumScreens; i++)
+	{
+	    if (i == idx) continue; /* Self replication is bad */
+
+	    pWin = (WindowPtr) LookupIDByType (pXinWin->info[i].id, RT_WINDOW);
+
+	    if (border)
+		pSrc = pWin->border.pixmap;
+	    else
+		pSrc = pWin->background.pixmap;
+
+	    break;
+	}
+    }
+
+    if (pSrc)
+    {
+	dmxPixPrivPtr pSrcPriv = DMX_GET_PIXMAP_PRIV (pSrc);
+
+	if (pSrcPriv->pixmap)
+	{
+	    DMXScreenInfo *dmxSrcScreen = &dmxScreens[i];
+	    DMXScreenInfo *dmxDstScreen = &dmxScreens[idx];
+	    dmxPixPrivPtr  pDstPriv = DMX_GET_PIXMAP_PRIV(pDst);
+	    XImage        *img = NULL;
+	    int            j;
+	    XlibGC         gc = NULL;
+
+	    /* This should never happen, but just in case.... */
+	    if (pSrc->drawable.width  != pDst->drawable.width ||
+		pSrc->drawable.height != pDst->drawable.height)
+		return;
+
+	    XLIB_PROLOGUE (dmxSrcScreen);
+
+	    /* Copy from src pixmap to dst pixmap */
+	    img = XGetImage(dmxSrcScreen->beDisplay,
+			    pSrcPriv->pixmap,
+			    0, 0,
+			    pSrc->drawable.width, pSrc->drawable.height,
+			    -1,
+			    ZPixmap);
+
+	    XLIB_EPILOGUE (dmxSrcScreen);
 
+	    if (img)
+	    {
 		for (j = 0; j < dmxDstScreen->beNumPixmapFormats; j++) {
 		    if (dmxDstScreen->bePixmapFormats[j].depth == img->depth) {
 			unsigned long  m;
@@ -742,26 +621,31 @@ static void dmxBERestorePixmapImage(poin
 			v.plane_mask = AllPlanes;
 			v.clip_mask = None;
 
+			XLIB_PROLOGUE (dmxDstScreen);
 			gc = XCreateGC(dmxDstScreen->beDisplay,
 				       dmxDstScreen->scrnDefDrawables[j],
 				       m, &v);
+			XLIB_EPILOGUE (dmxDstScreen);
 			break;
 		    }
 		}
 
 		if (gc) {
+		    XLIB_PROLOGUE (dmxDstScreen);
 		    XPutImage(dmxDstScreen->beDisplay,
 			      pDstPriv->pixmap,
 			      gc, img, 0, 0, 0, 0,
 			      pDst->drawable.width, pDst->drawable.height);
 		    XFreeGC(dmxDstScreen->beDisplay, gc);
+		    XLIB_EPILOGUE (dmxDstScreen);
 		    FoundPixImage = True;
 		} else {
 		    dmxLog(dmxWarning, "Could not create GC\n");
 		}
 
 		XDestroyImage(img);
-		return;
+	    } else {
+		dmxLog(dmxWarning, "Could not create image\n");
 	    }
 	}
     }
@@ -810,14 +694,17 @@ static void dmxBERestorePixmap(PixmapPtr
 		    v.plane_mask = AllPlanes;
 		    v.clip_mask = None;
 
+		    XLIB_PROLOGUE (dmxScreen);
 		    gc = XCreateGC(dmxScreen->beDisplay,
 				   dmxScreen->scrnDefDrawables[i],
 				   m, &v);
+		    XLIB_EPILOGUE (dmxScreen);
 		    break;
 		}
 	    }
 
 	    if (gc) {
+		XLIB_PROLOGUE (dmxScreen);
 		XPutImage(dmxScreen->beDisplay,
 			  pPixPriv->pixmap,
 			  gc,
@@ -825,6 +712,7 @@ static void dmxBERestorePixmap(PixmapPtr
 			  0, 0, 0, 0,
 		      pPixmap->drawable.width, pPixmap->drawable.height);
 		XFreeGC(dmxScreen->beDisplay, gc);
+		XLIB_EPILOGUE (dmxScreen);
 	    } else {
 		dmxLog(dmxWarning, "Cannot restore pixmap image\n");
 	    }
@@ -832,7 +720,10 @@ static void dmxBERestorePixmap(PixmapPtr
 	    XDestroyImage(pPixPriv->detachedImage);
 	    pPixPriv->detachedImage = NULL;
 	} else {
-	    dmxLog(dmxWarning, "Cannot restore pixmap image\n");
+	    dmxLog(dmxWarning, "Cannot restore pixmap image: %dx%d - %d\n",
+		   pPixmap->drawable.width,
+		   pPixmap->drawable.height,
+		   pPixmap->drawable.depth);
 	}
     }
 #else
@@ -888,11 +779,17 @@ static void dmxBECreateResources(pointer
     } else if ((type & TypeMask) == (RT_FONT & TypeMask)) {
 	(void)dmxBELoadFont(pScreen, (FontPtr)value);
     } else if ((type & TypeMask) == (RT_CURSOR & TypeMask)) {
-	dmxBECreateCursor(pScreen, (CursorPtr)value);
+	dmxBECreateCursor (pScreen, (CursorPtr) value);
+    } else if ((type & TypeMask) == (RT_PASSIVEGRAB & TypeMask)) {
+	GrabPtr grab = value;
+	if (grab->cursor)
+	    dmxBECreateCursor (pScreen, grab->cursor);
     } else if ((type & TypeMask) == (RT_COLORMAP & TypeMask)) {
 	ColormapPtr  pCmap = value;
 	if (pCmap->pScreen->myNum == scrnNum)
 	    (void)dmxBECreateColormap((ColormapPtr)value);
+    } else if ((type & TypeMask) == (DMX_SHMSEG & TypeMask)) {
+	dmxBEAttachShmSeg (&dmxScreens[scrnNum], (dmxShmSegInfoPtr) value);
 #if 0
 #ifdef RENDER
     /* TODO: Recreate Picture and GlyphSet resources */
@@ -930,9 +827,14 @@ static void dmxBECreateWindowTree(int id
 	dmxBERestorePixmap(pRoot->background.pixmap);
     }
 
+    dmxBECreateCursor (screenInfo.screens[idx], pRoot->optional->cursor);
+
     /* Create root window first */
     dmxScreen->rootWin = pWinPriv->window = dmxCreateRootWindow(pRoot);
-    XMapWindow(dmxScreen->beDisplay, dmxScreen->rootWin);
+
+#ifdef RENDER
+    if (pWinPriv->hasPict) dmxCreatePictureList (pRoot);
+#endif
 
     pWin = pRoot->lastChild;
     while (pWin) {
@@ -950,14 +852,17 @@ static void dmxBECreateWindowTree(int id
 	    dmxBERestorePixmap(pWin->background.pixmap);
 	}
 
+	if (wUseDefault(pWin, cursor, 0))
+	    dmxBECreateCursor (screenInfo.screens[idx],
+			       pWin->optional->cursor);
+
 	/* Reset the window attributes */
 	dmxGetDefaultWindowAttributes(pWin,
 				      &pWinPriv->cmap,
 				      &pWinPriv->visual);
 
 	/* Create the window */
-	if (pWinPriv->mapped && !pWinPriv->offscreen)
-	    dmxCreateAndRealizeWindow(pWin, TRUE);
+	dmxCreateAndRealizeWindow(pWin, TRUE);
 
 	/* Next, create the bottom-most child */
 	if (pWin->lastChild) {
